## newlib-m68hc1x 1.10.0-9

=== example/Makefile ===
#!/usr/bin/make -f

##################################################################
# Makefile for 68HC11 projects                                   #
# GNU copyright 2002-2003 by Aurelien Jarno <aurel32@debian.org> #
##################################################################

#
# Project files
#
PROG = test
ASMS = vectors.s
SRCS = main.c
INCLUDES = main.h ports.h 
OBJS = $(SRCS:.c=.o) $(ASMS:.s=.o)


#
# Libraries to use
#
LIBADD = -lc -lm -lbcc -lg


#
# C flags used by default to compile a program
#
CFLAGS = -m68hc11 -mshort -Wall -Wmissing-prototypes -Os -g0 -msoft-reg-count=0 -fomit-frame-pointer -ffixed-z 

LDFLAGS = -m68hc11 -mshort -Wl,-m,m68hc11elf \
	  -Wl,-defsym,_io_ports=0x1000


#
# Options to creates the .s19 or .b files from the elf
#
OBJCOPY_FLAGS=--only-section=.text \
              --only-section=.rodata \
              --only-section=.vectors \
              --only-section=.data


####################################
# This part should not be modified #
####################################
#
# Programs location
#
DEVC_PREFIX=m68hc11-
CC=$(DEVC_PREFIX)gcc
CXX=$(DEVC_PREFIX)gcc
AS=$(DEVC_PREFIX)as
AR=$(DEVC_PREFIX)ar
SIZE=$(DEVC_PREFIX)size
OBJCOPY=$(DEVC_PREFIX)objcopy
OBJDUMP=$(DEVC_PREFIX)objdump
LD=$(DEVC_PREFIX)ld

#
# Main rules
#
all: 	$(PROG).elf $(PROG).s19 $(PROG).b

$(PROG).elf: $(OBJS) $(INCLUDES)
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LIBADD)

clean:
	rm -f *.o *.elf *.s19 *.b *.a

#
# Some useful rules
#
dump:	$(PROG).elf
	$(OBJDUMP) -d $(PROG).elf

size:   $(PROG).s19
	$(SIZE) $(PROG).s19


#
# Implicit rules
#
# .elf is for the simulator and gdb
# .s19 is for some downloader and the simulator
# .b   is a binary dump
#
.SUFFIXES: .elf .s19 .b

.elf.s19:
	$(OBJCOPY) --output-target=srec $(OBJCOPY_FLAGS) $< $*.s19

.elf.b:
	$(OBJCOPY) --output-target=binary --gap-fill=255 \
                   --only-section=.data $(OBJCOPY_FLAGS) $< $*.b

=== debian/changelog ===
newlib-m68hc1x (1.10.0-9) unstable; urgency=low

  * Updated example.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 18 Apr 2004 04:45:27 +0200

newlib-m68hc1x (1.10.0-8) unstable; urgency=low

  * Rebuilt using gcc-3.3.3.
  * Bumped standards-version to 3.6.1

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 11 Apr 2004 11:56:47 +0200

newlib-m68hc1x (1.10.0-7) unstable; urgency=low

  * Added a lintian override file to remove all "arch-independent-package-
    contains-binary-or-object" errors. The files are binary files, but
    compiled for a non Debian target processor.

 -- Aurelien Jarno <aurel32@debian.org>  Tue,  8 Jul 2003 01:24:13 +0200

newlib-m68hc1x (1.10.0-6) unstable; urgency=low

  * Changed the package to arch-indep as it only contains a cross-compiled
    library and the corresponding headers.
  * Bumped standards-version to 3.5.10.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 25 May 2003 22:31:33 +0200

newlib-m68hc1x (1.10.0-5) unstable; urgency=low

  * Depends on ${misc:Depends}.
  * Uses debian/compat instead of DH_COMPAT.
  * Removed call to dh_undocumented.
  * Bumped standards-version to 3.5.9.

 -- Aurelien Jarno <aurel32@debian.org>  Tue,  8 Apr 2003 11:17:49 +0200

newlib-m68hc1x (1.10.0-4) unstable; urgency=low

  * More fixes in example code. 

 -- Aurelien Jarno <aurel32@debian.org>  Wed,  8 Jan 2003 15:41:26 +0100

newlib-m68hc1x (1.10.0-3) unstable; urgency=low

  * Fixed code in example. 

 -- Aurelien Jarno <aurel32@debian.org>  Tue,  7 Jan 2003 10:29:33 +0100

newlib-m68hc1x (1.10.0-2) unstable; urgency=low

  * Added some example code to /usr/share/doc/newlib-m68hc1x/
  * Bumped Standards-Version to 3.5.8

 -- Aurelien Jarno <aurel32@debian.org>  Mon,  6 Jan 2003 23:34:05 +0100

newlib-m68hc1x (1.10.0-1) unstable; urgency=low

  * Initial Release (closes: bug#172577).

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 13 Dec 2002 01:17:28 +0100

Local variables:
mode: debian-changelog
End:

=== debian/control ===
Source: newlib-m68hc1x
Section: devel
Priority: extra
Maintainer: Aurelien Jarno <aurel32@debian.org>
Standards-Version: 3.6.1
Build-Depends-Indep: autoconf (>= 2.13), debhelper (>= 4.0), gcc-m68hc1x (>= 3.3.3-1), tar (>= 1.13.18), bzip2, gzip, patch, toolchain-source-newlib (>= 3.3)

Package: newlib-m68hc1x
Architecture: all
Section: devel
Priority: extra
Depends: ${shlibs:Depends}, ${misc:Depends}, gcc-m68hc1x (>= 3.3.3-1)
Conflicts: gcc-m68hc1x (<< 3.3.3-3)
Suggests: task-c-devel
Description: The newlib library built for Motorola's 68HC11/12 targets
 Newlib is a C library intended for use on embedded systems. It is a
 conglomeration of several library parts, all under free software licenses
 that make them easily usable on embedded products.
 .
 This package contains the newlib library compiled for Motorola's 68HC11/12 
 targets.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_BUILD_GNU_TYPE      := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE       := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

unpack: unpack-stamp
unpack-stamp:
	tar xjf /usr/src/toolchain/newlib-1.10.0.tar.bz2
	for i in $(CURDIR)/patches/* ; do \
		patch -p0 < $$i ; \
	done
	mv newlib* src
	mkdir build
	touch unpack-stamp

configure: configure-stamp
configure-stamp: unpack-stamp
	dh_testdir

	# Add here commands to configure the package.
	cd build && \
	../src/configure --prefix=/usr \
                         --target=m68hc11 \
                         --build=$(DEB_BUILD_GNU_TYPE) \
                         --host=$(DEB_HOST_GNU_TYPE)
	touch configure-stamp

build: configure-stamp build-stamp
build-stamp:
	dh_testdir
	cd build && CFLAGS="-Os -Wall -mrelax" $(MAKE)
	tar cfz $(CURDIR)/example.tar.gz example
	touch build-stamp

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
 
	# Main install
	cd build && $(MAKE) install prefix=$(CURDIR)/debian/newlib-m68hc1x/usr

	# Change hardlinks to symlinks
	ln -sf libc.a $(CURDIR)/debian/newlib-m68hc1x/usr/m68hc11/lib/libg.a
	ln -sf libc.a $(CURDIR)/debian/newlib-m68hc1x/usr/m68hc11/lib/mshort/libg.a
	ln -sf libc.a $(CURDIR)/debian/newlib-m68hc1x/usr/m68hc11/lib/mshort/fshort-double/libg.a
	ln -sf libc.a $(CURDIR)/debian/newlib-m68hc1x/usr/m68hc11/lib/fshort-double/libg.a
	
	ln -sf libc.a $(CURDIR)/debian/newlib-m68hc1x/usr/m68hc11/lib/m68hc12/libg.a
	ln -sf libc.a $(CURDIR)/debian/newlib-m68hc1x/usr/m68hc11/lib/m68hc12/mshort/libg.a
	ln -sf libc.a $(CURDIR)/debian/newlib-m68hc1x/usr/m68hc11/lib/m68hc12/mshort/fshort-double/libg.a
	ln -sf libc.a $(CURDIR)/debian/newlib-m68hc1x/usr/m68hc11/lib/m68hc12/fshort-double/libg.a

	# Strip files
	find $(CURDIR)/debian/newlib-m68hc1x -name "*.o" -or -name "*.a" -exec /usr/bin/m68hc11-strip --strip-debug {} \;

	# Override file
	install -p -d -o root -g root -m 755 $(CURDIR)/debian/newlib-m68hc1x/usr/share/lintian/overrides
	install -p -o root -g root -m 644 $(CURDIR)/debian/overrides $(CURDIR)/debian/newlib-m68hc1x/usr/share/lintian/overrides/newlib-m68hc1x

clean:
	dh_testdir
	dh_testroot
	make -C example/ clean
	rm -f $(CURDIR)/example.tar.gz
	rm -rf src build patch-stamp*
	rm -f build-stamp configure-stamp unpack-stamp 

	dh_clean


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
#	dh_installdebconf
	dh_installdocs
#	dh_installexamples
#	dh_installmenu
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
	dh_installman
#	dh_installinfo
	dh_installchangelogs
	dh_link
	dh_strip --exclude=.o --exclude=.a
	dh_compress
	dh_fixperms
#	dh_makeshlibs
	dh_installdeb
#	dh_perl
#	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
